
package com.six15.hudservice;

// Declare any non-default types here with import statements

import com.six15.hudservice.ImageFrame;
import com.six15.hudservice.ByteFrame;
import com.six15.hudservice.CameraResolution;
import com.six15.hudservice.IHudServiceCallback;

interface IHudService {

	  boolean isInited();
	  void registerCallback(IHudServiceCallback cb);
      void unregisterCallback(IHudServiceCallback cb);

      boolean checkCallback(IHudServiceCallback cb);

      boolean setAutoResizeImage(boolean enable);
      boolean getAutoResizeEnabled();
      boolean getHudConnected();
      boolean getScreenCaptureEnabled();
      int getSplashScreenEnabled();
      int getHudDisplaySize();
      float getLastFrameBufferTime();
      int getHudVersions();
      int getHudInfo();
      int getHudSettings();
      int setHudSettings(boolean autoResize, boolean splashEnable, byte defBrightness);
      int setHudDefaultSettings();
      int getDisplayInfo();
      int getImuStatus();
      int startImu();
      int stopImu();
      int sendPing();
      int setDisplayOn(boolean onOff);
      int getDisplayOn();
      int setBrightnessLevel(byte level);
      int getBrightnessLevel();
      int getCameraSnapshot();
      int startCameraCapture();
      int stopCamera();
      boolean clearHudDisplay();
      boolean sendJpegToHud(String filePath);
      boolean sendImageToHud(in ImageFrame imageFrame);
      boolean sendBufferToHud(in ByteFrame byteFrame);
      int doQueryHudMode();
      int doHudSoftReset();
      boolean bootloaderUpdateModeLegacy();
      int doFirmwareUpdate();
      int doBootloaderUpdate();
      List<String> getAvailableFirmware();
      List<String> getAvailableBootloaders();
      String getSDKVersion();
      void setCameraEnabled(boolean cameraEnable);
      boolean getCameraEnabled();
      boolean getPresentationEnabled();
      String getFirmwareVersion();
      String getAvailableFirmwareVersion();
      boolean getMicrophoneEnabled();
      void setMicrophoneEnabled(boolean microphoneEnable);
      boolean setUserData(String data);
      String getUserData();
      String getHudInfromation();
      int startRawCameraCapture();
      int getHudOperationMode();
      boolean setHudOperationMode(int mode, boolean bStopOnly);
      boolean getCameraAutofocusMode();
      void setCameraAutofocusMode(boolean bAutofocusOn);
      List<CameraResolution> getSupportedCameraResolutions();
      CameraResolution getCurrentCameraResolution();
      boolean setCameraResolution(in CameraResolution cam_res);
      int getCameraZoom();
      boolean setCameraZoom(int zoom);
      void startScreenCaptureCommand(int resultCode, in Intent data, int mode);
      int getHudDebugTerminal();
      String getExtraVersions();
      int set720Framerate(byte value);
      int get720Framerate();
      boolean startUserImuCal(int imuSensor);
      boolean getUserImuCal(int imuSensor);
      int setImuFilterTune(float gain, float zeta);
      int getAggressiveDisplayPowerSavingEnabled();
      int setAggressiveDisplayPowerSavingEnabled(boolean enabled);
      boolean hasCamera();
      int setDitherEnabled(boolean enabled);
      boolean isConnectedOverLowBandwidthLink();
      int sendDisplayText(String text);
      int clearDisplayText();
}
